<template>
	<view class="search-container">
		<view class="search-main">
			<view class="search-input">
				<text class="iconfont icon-iconfonticonfontsousuo1"></text>
				<input maxlength="20" :focus="isFocus" type="text" value="" confirm-type="search" @focus="onFocus" @input="onShowClose" @confirm="subMitSearch()" placeholder="请输入商品关键词" v-model.trim="searchInputVal"/>
				<text class="iconfont icon-shanchu1" v-if="isShowClose" @click.stop="delInputText()"></text>
			</view>
			<view class="search-btn" @click="subMitSearch()">搜索</view>
		</view>
		<view class="search-container-history" v-if="!isShowWrapper">
			<view :class="'s-' + themeClass" v-if="serachRecordList.length>0">
				<view class="header">
					搜索历史<text class="iconfont icon-shanchu" @click="confirmDetele"></text>
				</view>
				<view class="list">
					<view v-for="(item,index) in serachRecordList" :key="index" @click="keywordsClick(item.searchWord)">{{item.searchWord}}</view>
				</view>
			</view>
		</view>
		<view v-else class="commodity-list-wrapper"  :style="{'overflow':'auto','height':(listData.length>4? windowHeight + 'px' : 'auto')}">
			<scroll-view :style="{'height':(listData.length>4? scrollHeight+'px' : 'auto')}" @scrolltolower="scrolltolower" scroll-y v-if="!showEmpty">
				<view v-for="(item,index) in listData" :key="index" :id="item.id" class="all-type-list-content commodity-list" @click.stop="navToDetailPage(item.p_id)">
					<image mode='widthFix' :src="item.p_image"  class="list-img" alt="list-img"></image>
					<view class="list-details-info">
						<view class="list-details-title">{{isInterceptHtmlFn(item.p_name)}}</view>
						<text class="list-details-specs">规格：{{item.p_unit}}</text>
						<view class="list-details-specs" v-if="item.p_code!=''&&item.p_code!=null">
							<view>商品编码：{{item.p_code}}</view>
						</view>
						<view class="list-details-price">
							<view v-if="hasLogin"class="list-price">
								<view v-if="userIdentity == 1">
									<text v-if="priceLoading" class="price-larger small">正在获取价格...</text>
									<text v-else>￥<text class="price-larger">{{item.price?item.price :'0.00'}}</text></text>
								</view>	
								<view v-if="userIdentity == 4">
									<view class="price-larger" v-if="item.p_price_flag == '1'">
										<text class="txt">未公开价格</text>
									</view>
									<text v-else-if="priceLoading" class="price-larger small">正在获取价格...</text>
									<view v-else>
										<view class="price-larger" v-if="item.p_price_flag == '2'">
											<text class="txt">价格仅会员可见</text>
											<text class="btn" @click.stop="this.$api.navigateTo(`/pages/login/apply?clubStatus=${clubStatus}`)">去升级</text>
										</view>
										<text v-else>￥<text class="price-larger">{{item.price ?item.price :'0.00'}}</text></text>
									</view>
								</view>
								<view v-if="userIdentity == 2">
									<view class="price-larger" v-if="item.p_price_flag == '1'">
										<text class="txt">未公开价格</text>
									</view>
									<text v-else-if="priceLoading" class="price-larger small">正在获取价格...</text>
									<text v-else>￥<text class="price-larger">{{item.price ? item.price :'0.00'}}</text></text>
								</view>
							</view>	
							<view  v-else class="list-login-now">
								<text class="p-no">价格:</text>
								<uni-stars :stars="parseInt(item.p_price_grade)" :font-size='36' :width-info="180"></uni-stars>
							</view>
						</view>
					</view>
				</view>
				<view v-if="showLoading && listData.length > 4">
					<view class="loading-wrapper loading-wrapper-now" v-if="loadingNow">{{loadingText}}<text v-if="loadingText === '已至底部'">‧ ‧ ‧</text></view>
					<view class="loading-wrapper loading-wrapper-btm" v-else>———<text class="btm-text">已至底部</text>———</view>
				</view>
			</scroll-view>
			<view class="empty-container" v-if="showEmpty">
				<image class="empty-container-image" src="https://img.caimei365.com/group1/M00/03/8D/Cmis215XHXWAHCoqAAELHadZ9Xg365.png"></image>
				<text class="error-text">抱歉，没有相关商品！</text>
			</view>
		</view>
		<!-- 透明模态层 -->
		<modal-layer v-if='isModallayer'></modal-layer>
	</view>
</template>

<script>
	import { mapState,mapMutations } from 'vuex'
	import modalLayer from "@/components/modal-layer"
	import uniStars from '@/components/uni-stars/uni-stars.vue'
	import authorize from '@/common/config/authorize.js'
	
	export default {
		components: {
			modalLayer,
			uniStars
		},
		data() {
			return {
				userID:'',
				themeClass: 'block',
				searchInputVal:'',	//搜索关键词
				userIdentity:'',	
				identity:2,
				isShowClose:false,	//是否显示清空输入框图标
				isSearchHistory:false,//是都显示搜索历史
				serachRecordList:[],//历史搜索记录
				isShowWrapper:false,
				isModallayer:false,
				isFocus:false,
				priceLoading:true,
				windowHeight: '',
				showEmpty: false,
				scrollHeight: '',
				listData: [],
				productIds:'',//查询价格的商品ID
				showLoading: false,
				loadingNow: true,
				loadingText: '上拉加载更多',
				pageSize: 20,
				pageNum: 1,
				hasNextPage: false,
				totalPage: 1,
				pullFlag: true,
			}
		},
		onLoad() {
			this.isFocus = true
			this.initGetSerachRecord()			
		},
		computed: {
			...mapState(['hasLogin','userInfo'])
		},
		methods:{
			initGetSerachRecord(){
				this.$api.getStorage().then((resolve) =>{
					this.userID = resolve.userID ? resolve.userID : '';
					this.userIdentity = resolve.userIdentity ? resolve.userIdentity : '';
					if(this.userIdentity == 1){
						this.identity = 1
					}else{
						this.identity = 2
					}
				    this.ProductService.GetProductSearchHistory({userId:this.userID}).then(response =>{
						if(response.code == 0){
							this.serachRecordList = response.data
						}
				    })
				})	
			},
			subMitSearch() {
				if (this.searchInputVal == '') {
					this.$util.msg('请输入商品关键词',2000);
				}else{
					this.listData =[]
					this.setSearchHistoryAdd()
					this.getListFromServer()
					this.isFocus = false
				}
			},
			scrolltolower() {
				if(this.totalPage>this.listData.length && this.pullFlag) {
					this.getListFromServer(true);
				}
			},
			getListFromServer(loadMore) {
				this.showLoading = true;
				this.loadingNow = true;
				this.loadingText = '加载中';
				this.showEmpty = false;				
				if(loadMore) {
					this.pageNum += 1;
				}
				let params = {
						identity:this.identity,
						keyword:this.searchInputVal,
						pageNum:this.pageNum,
						pageSize:this.pageSize,
						sortField:'',
						sortType:'',
					}
				this.ProductService.GetProductSearchList(params).then(response =>{
					this.isShowWrapper = true
					const resData = JSON.parse(response.data);
					const resList = resData.items;
					// console.log(resData)
					if(resList && resList.length > 0){
						this.totalPage = resData.total;
						this.showEmpty = false;
						if(loadMore) {
							this.listData = [...this.listData,...resList];
							this.setProductPrice()
						} else {
							this.listData = [...resList];
							this.setProductPrice()
						}
						// 防上拉暴滑
						this.pullFlag = false;
						setTimeout(()=>{ this.pullFlag = true; },500)
						// 底部提示文案
						if(this.totalPage>this.listData.length) {
							this.loadingText = '上拉加载更多';
						} else {
							this.showLoading = true;
							this.loadingNow = false;
						}
					} else {
						if(!loadMore) {
							this.showEmpty = true;
						}
					}
				}).catch(error =>{
					this.$util.msg(error.msg,2000);
				})
			},
			setSearchHistoryAdd(){//添加搜索记录
				if (!this.hasLogin) {return false;}
				this.ProductService.GetAddProductSearchHistory({userId: this.userID,keyword:this.searchInputVal}).then(response =>{
					//此为每次搜索同时添加用户的搜索记录
				}).catch(error =>{
					this.$util.msg(error.msg,2000);
				})
			},
			setProductPrice(){//获取价格
				if (!this.hasLogin) {return false;}
				let productIdArr = [];
				this.listData.map(item=>{// 0公开价格 1不公开价格 2仅对会员机构公开
					productIdArr.push(item.p_id)
				})
				this.productIds = productIdArr.join(",");
				this.ProductService.querySearchProductPrice({userId: this.userID,productIds:this.productIds}).then(response =>{
					if (response.data) {
						let priceList = response.data
						this.listData.map(item=>{
							for (let i = 0; i < priceList.length; i++) {
								let priceObj ={
										actStatus:priceList[i].actStatus,
										costCheckFlag:priceList[i].costCheckFlag,
										costPrice:priceList[i].costPrice,
										costProportional:priceList[i].costProportional,
										ladderPriceFlag:priceList[i].ladderPriceFlag,
										price:Number(priceList[i].price).toFixed(2),
										minBuyNumber:priceList[i].minBuyNumber
								}
								if( item.p_id == priceList[i].productId ){
									Object.assign(item,priceObj)
								}
							}
						});
					}
					this.priceLoading = false;
				}).catch(error =>{
					this.$util.msg(error.msg,2000)
				})
			},
			onShowClose () {//输入框输入时触发
				this.inputEmpty(this.searchInputVal)
			},
			onFocus () { //输入框获取焦点时触发
				this.inputEmpty(this.searchInputVal)
				this.initGetSerachRecord()
			},
			delInputText () { //清除输入框内容
				this.searchInputVal = ''
				this.isShowClose = false
				this.isShowWrapper = false
				this.inputEmpty(this.searchInputVal)
				this.initGetSerachRecord()
			},
			keywordsClick (item) {//关键词搜索与历史搜索
				this.searchInputVal = item;
				this.isShowClose = true;
				this.subMitSearch();
			},
			confirmDetele() {//清空历史记录
				this.$util.modal('提示','确定删除历史记录？','确定','取消',true,() =>{
					this.ProductService.GetDeleteProductSearchHistory({userId:this.userID}).then(response =>{
						this.$util.msg('删除成功',2000,true,'success')
						this.serachRecordList=[];
					}).catch(error =>{
						this.$util.msg(error.msg,2000)
					})
				})
			},
			inputEmpty(val){
				this.isShowWrapper = false
				if(val != ''){
					this.isShowClose = true
					this.isFocus = true
				}else{					
					this.isShowClose = false
					this.isFocus = true
				}
			},
			isInterceptHtmlFn(text){
				let name = this.$reg.interceptHtmlFn(text)
				return name
			},
			navToDetailPage(id) {
				this.isModallayer = true;
				this.$api.navigateTo(`/pages/goods/product?id=${id}`);
				this.isModallayer = false;
			},
			setScrollHeight() {
				const {windowHeight, pixelRatio} = wx.getSystemInfoSync();
				this.windowHeight = windowHeight - 1;
				this.scrollHeight = windowHeight - 1;
			},
			toLoginPage() {
				let searchLoginType = 'search'
				uni.navigateTo({
					url:`/pages/login/login?type=${searchLoginType}`
				})
			}
		},
		onShow() {
			this.setScrollHeight();
		}
	}
</script>

<style lang="scss">
	@import "@/uni.scss";
	page{
		background-color: #F7F7F7 !important;
	}
	.search-main{
		width: 702rpx;
		height: 70rpx;
		padding: 12rpx 24rpx;
		border-bottom: 1px solid #F0F0F0;
		position: fixed;
		top: 0;
		left: 0;
		background: #FFFFFF;
		z-index: 1001;
		.search-input{
			width: 448rpx;
			height: 70rpx;
			padding: 0 68rpx;
			line-height: 70rpx;
			border-radius: 40rpx;
			position: relative;
			background: #F0F0F0;
			float: left;
			.icon-iconfonticonfontsousuo1{
				display: block;
				width: 68rpx;
				font-size: 36rpx;
				color: #8A8A8A;
				position: absolute;
				left: 24rpx;
				z-index: 10;
			}
			.icon-shanchu1{
				display: block;
				width: 68rpx;
				font-size: 36rpx;
				text-align: center;
				color: #999;
				position: absolute;
				right: 0;
				top: 0;
				z-index: 60;
			}
			input{
				width: 448rpx;
				height: 70rpx;
				background-color: #F0F0F0;
				font-size: 26rpx;
			}
		}
		.search-btn{
			width: 118rpx;
			height: 70rpx;
			line-height: 70rpx;
			color: $color-system;
			font-size: 30rpx;
			text-align: center;
			float: left;
		}
		.voice-icon{
			width: 36rpx;
			height: 36rpx;
			padding: 16rpx 20rpx 16rpx 0;
			position: absolute;
			left: 16rpx;
			top: 4rpx;
			z-index: 10;
		}
		
	}
	.search-container{
		padding-top: 106rpx;
	}
	.s-block{
		background: #FFFFFF;
		.header{
			font-size: 32rpx;
			padding:40rpx 24rpx 22rpx 24rpx;
			line-height: 42rpx;
			font-size: 30rpx;
			font-weight: bold;
			position: relative;
			.icon-shanchu{
				font-size: 36rpx;
				color: #333333;
				float: right;
				padding: 0 10rpx;
				z-index: 10;
				font-weight: normal;
			}
		}
		.list{
			display: flex;
			flex-wrap: wrap;
			padding-bottom: 40rpx;
			view{
				color: #8A8A8A;
				font-size: 24rpx;
				box-sizing: border-box;
				text-align: center;
				height: 48rpx;
				line-height: 48rpx;
				border-radius: 24rpx;
				margin:12rpx;
				padding:.0 30rpx;
				overflow: hidden;
				white-space: nowrap;
				text-overflow: ellipsis;
				background-color: #F3F3F3;
			}
		}
	}
	.s-circle{
		margin-top: 30rpx;
		.header{
			font-size: 32rpx;
			padding: 30rpx;
			border-bottom: 2rpx solid #F9F9F9;
			position: relative;
			image{
				width: 36rpx;
				height: 36rpx;
				padding: 10rpx;
				position: absolute;
				right: 40rpx;
				top: 24rpx;
			}
		}
		.list{
			display: flex;
			flex-wrap: wrap;
			padding: 0 30rpx 20rpx;
			view{
				padding: 8rpx 30rpx;
				margin: 20rpx 30rpx 0 0;
				font-size: 28rpx;
				color: #8A8A8A;
				background-color: #F7F7F7;
				box-sizing: border-box;
				text-align: center;
				border-radius: 20rpx;
			}
		}
	}
	.wanted-block{
		margin-top: 30rpx;
		.header{
			font-size: 32rpx;
			padding: 30rpx;
		}
		.list{
			display: flex;
			flex-wrap: wrap;
			view{
				width: 50%;
				color: #8A8A8A;
				font-size: 28rpx;
				box-sizing: border-box;
				text-align: center;
				padding: 20rpx 0;
				border-top: 2rpx solid #FFF;
				border-left: 2rpx solid #FFF;
				background-color: #F7F7F7;
				overflow: hidden;
				white-space: nowrap;
				text-overflow: ellipsis;
			}
		}
	}
	.wanted-circle{
		margin-top: 30rpx;
		.header{
			font-size: 32rpx;
			padding: 30rpx;
		}
		.list{
			display: flex;
			flex-wrap: wrap;
			padding: 0 30rpx 20rpx;
			view{
				padding: 8rpx 30rpx;
				margin: 20rpx 30rpx 0 0;
				font-size: 28rpx;
				color: #8A8A8A;
				background-color: #F7F7F7;
				box-sizing: border-box;
				text-align: center;
				border-radius: 20rpx;
			}
		}
	}
	.commodity-list-wrapper {
		scroll-view {
			height: 100%;
			overflow: scroll;
		}	
		.empty-container-image {
			margin-top: -300rpx;
		}
		.toIndexPage {
			bottom: 390rpx;
		}
		.show-more-btn {
			width: 276rpx;
			height: 52rpx;
			line-height: 52rpx;
			border: 2rpx solid #D8D8D8;
			background: #F7F7F7;
			font-size: 26rpx;
			margin: 26rpx 0;
			position: absolute;
			left: 50%;
			margin-left: -138rpx;
		}
	}
	.all-type-list-content {
		height: 216rpx;
		padding: 24rpx;
		background: #fff;
		margin-bottom: 2rpx;
		display: flex;
		flex-direction: row;
		box-sizing: content-box;
		.list-img {
			width: 210rpx;
			height: 218rpx !important;
			margin-right: 26rpx;
			border-radius: 10rpx;
			border: 2rpx solid #f3f3f3;
		}
	}
	.list-details-info {
		width: 466rpx;
		display: flex;
		flex-direction: column;
		font-size: 26rpx;
		position: relative;
		.list-details-title {
			line-height: 38rpx;
			text-overflow: ellipsis;
			overflow: hidden;
			display: -webkit-box;
			-webkit-line-clamp: 2;
			line-clamp: 2;
			-webkit-box-orient: vertical;
		}
		.list-details-specs {
			margin-top: 8rpx;
			color: #666666;
		}
		.list-details-miniQuantity {
			margin-top: 7rpx;
		}
	}
	.list-details-price {
		width: 100%;
		flex-direction: row;
		justify-content: space-between;
		position: absolute;
		bottom: 0;
		right: 0;
		.price-icon {
			width: 22rpx;
			height: 28rpx;
			vertical-align: middle;
			margin-right: 10rpx;
		}
		.price-icon + text {
			font-size: 25rpx;
			vertical-align: middle;
		}
		.list-login-now {
			width: 375rpx;
			color: #F8C499;
			position: absolute;
			bottom: 0;
			.p-no{
				float: left;
				font-size: $font-size-24;
				color: $color-system;
				margin-right: 10rpx;
			}
		}
		.login-now {
			padding: 10rpx 10rpx 10rpx 0;
		}
		.list-price {
			color: #FF2A2A;
			.price-larger {
				width: 100%;
				font-size: 32rpx;
				&.small{
					font-size: $font-size-24;
				}
				.txt{
					font-size: $font-size-24;
					display: inline-block;
					line-height: 44rpx;
					text-align: left;
					float: left;
				}
				.btn{
					width: 112rpx;
					height: 44rpx;
					display: inline-block;
					float: right;
					background: $btn-confirm;
					line-height: 44rpx;
					text-align: center;
					color: #FFFFFF;
					font-size: $font-size-24;
					border-radius: 22rpx;
				}
			}
		}
	}
</style>
